/**********************************************************************
 
	Copyright (C) 2003 Hirohisa MORI <joshua@nichibun.ac.jp>
 
	This program is free software; you can redistribute it 
	and/or modify it under the terms of the GLOBALBASE 
	Library General Public License (G-LGPL) as published by 

	http://www.globalbase.org/
 
	This program is distributed in the hope that it will be 
	useful, but WITHOUT ANY WARRANTY; without even the 
	implied warranty of MERCHANTABILITY or FITNESS FOR A 
	PARTICULAR PURPOSE.

**********************************************************************/


#include	<unistd.h>
#include	<stdlib.h>
#include	<sys/types.h>
#include	<sys/processor.h>
#include	"utils.h"
#include	"limits.h"
#include	"machine/sys_param.h"

int
_numofcpu()
{
int i;
processor_info_t info;
int ret;
	ret = 0;
	for ( i = 0 ; ; i ++ ) {
		if ( processor_info((processorid_t)i,&info) < 0 )
			break;
		if ( info.pi_state == P_ONLINE )
			ret ++;
	}
	return ret;
}
